<?php

/**
 * resolucion_titulo actions.
 *
 * @package    cobro_coactivo
 * @subpackage resolucion_titulo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class resolucion_tituloActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_RESOLUCION_TIT_V',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'CBR_CONCEPTO_RESOL',
        'CBR_ENTIDAD_EXPIDE',
        'CBR_REMISION_TITULO_DET_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_RESOLUCION_TIT_V'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_RESOLUCION_TIT_V'
        ),
        'CBR_CONCEPTO_RESOL' =>
        array(
            'id_concepto_resol' => 'CBR_RESOLUCION_TIT_V'
        ),
        'CBR_ENTIDAD_EXPIDE' =>
        array(
            'id_entidad_expide' => 'CBR_RESOLUCION_TIT_V'
        ),
        'CBR_REMISION_TITULO_DET_V' =>
        array(
            'id_remision_titulo_det' => 'CBR_RESOLUCION_TIT_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_RESOLUCION_TIT_V' =>
        array(
            'id_resolucion_tit' => 'id_resolucion_tit',
            'cod_titulo' => 'cod_titulo',
            'id_concepto_resol' => 'id_concepto_resol',
            'fecha_expedicion' => 'fecha_expedicion',
            'fecha_ejecutoria' => 'fecha_ejecutoria',
            'no_resolucion' => 'no_resolucion',
            'fecha_exigibilidad' => 'fecha_exigibilidad',
            'fecha_fin_exigibilidad' => 'fecha_fin_exigibilidad',
            'id_entidad_expide' => 'id_entidad_expide',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'titulo_vigente' => 'titulo_vigente',
            'id_remision_titulo_det' => 'id_remision_titulo_det',
            'no_resolucion_text' => 'no_resolucion_text',
            'date_expedicion_text' => 'date_expedicion_text'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'CBR_CONCEPTO_RESOL' =>
        array(
            'codigo' => 'codigo',
            'descripcion' => 'descripcion_concepto'
        ),
        'CBR_ENTIDAD_EXPIDE' =>
        array(
            'descripcion' => 'descripcion_entidad'
        ),
        'CBR_REMISION_TITULO_DET_V' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'observaciones' => 'observaciones',
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'numero_correpondencia' => 'numero_correpondencia',
            'fecha_remision' => 'fecha_remision',
            'id_par' => 'id_par',
            'no_folios' => 'no_folios',
            'estado' => 'estado',
            'numero_remision,||, - ,||,anho_remision' => 'completo_remision'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'anho_remision', 'numero_remision', 'cod_titulo', 'fecha_ejecutoria', 'descripcion_concepto'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     * IN - where de in de oracle, para numero
     * INTEXT - where de in de oracle, para texto
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_RESOLUCION_TIT_V' =>
        array(
            'id_resolucion_tit,a' => array('!=' => array(-1)),
            'id_resolucion_tit,b' => array('=' => array('id_resolucion_tit')),
            'cod_titulo' => array('=' => array('cod_titulo')),
            'id_concepto_resol' => array('IN' => array('id_concepto_resol')),
            'no_resolucion' => array('=' => array('no_resolucion')),
            'id_entidad_expide' => array('=' => array('id_entidad_expide')),
            'fecha_ejecutoria' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_REMISION_TITULO_DET_V' =>
        array(
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'numero_remision' => array('=' => array('numero_remision')),
            'anho_remision' => array('=' => array('anho_remision')),
            'estado' => array('=' => array('estado'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_resolucion_tit'; //identificador de la tabla
    protected $id_names = array('id_resolucion_tit'); //llave primaria
    protected $field_names = array('cod_titulo', 'id_concepto_resol', 'fecha_expedicion',
        'fecha_ejecutoria', 'no_resolucion', 'fecha_exigibilidad', 'fecha_fin_exigibilidad',
        'id_entidad_expide', 'usuario_log', 'titulo_vigente', 'id_remision_titulo_det'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_RESOLUCION_TIT'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_resolucion_tit'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $usuario_log = $request['id_username'];

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                //Inserta los demas entidades - 20160526
                $conceptos = $request['id_conceptos'];
                $conceptos = explode(',', $conceptos);

                $cod_titulo = $request['cod_titulo'];
                $fecha_expedicion = $request['fecha_expedicion'];
                $fecha_ejecutoria = $request['fecha_ejecutoria'];
                $no_resolucion = $request['no_resolucion'];
                $fecha_exigibilidad = $list_data_post[0]['fecha_exigibilidad'];
                $id_entidad_expide = $request['id_entidad_expide'];
                $fecha_fin_exigibilidad = $list_data_post[0]['fecha_fin_exigibilidad'];
                $id_remision_titulo_det = $list_data_post[0]['id_remision_titulo_det'];

                $titulo_vigente = 0;
                if (isset($request['titulo_vigente']) && $request['titulo_vigente'] == 'true') {
                    $titulo_vigente = 1;
                }

                for ($i = 1; $i < count($conceptos); $i++) {

                    $id = $conceptos[$i];

                    $sql = <<<EOD
Insert into CBR_RESOLUCION_TIT (ID_RESOLUCION_TIT,COD_TITULO,ID_CONCEPTO_RESOL,FECHA_EXPEDICION,FECHA_EJECUTORIA,NO_RESOLUCION,
FECHA_EXIGIBILIDAD,ID_ENTIDAD_EXPIDE,FECHA_FIN_EXIGIBILIDAD,USUARIO_LOG,TITULO_VIGENTE,ID_REMISION_TITULO_DET) 
  values (null,'$cod_titulo','$id',to_date('$fecha_expedicion','YYYY-MM-DD'),to_date('$fecha_ejecutoria','YYYY-MM-DD'),'$no_resolucion',
      to_date('$fecha_exigibilidad','YYYY-MM-DD'),'$id_entidad_expide',to_date('$fecha_fin_exigibilidad','YYYY-MM-DD'),$usuario_log,$titulo_vigente,$id_remision_titulo_det)
EOD;
                    //insertar cada cdp
                    CN_TABLE::executeSQL($sql);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
                $this->status = 1;
                $this->mensajeError = "[investiga_bienes] Ocurrio un error: " . $e->getMessage();
                $this->list_data = array();
                $this->logMessage("[investiga_bienes] ERROR!");
                $this->logMessage($e->getMessage());
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];

            $fecha_ejecutoria = $request['fecha_ejecutoria'];

            //para la fecha fecha_fin_exigibilidad es sin el dia de mas - 20200918::LAVILA
            $sql = <<<EOD
select to_char(to_date('$fecha_ejecutoria','YYYY-MM-DD') + INTERVAL '1' DAY,'YYYY-MM-DD') as fecha_exigibilidad,
       to_char(to_date('$fecha_ejecutoria','YYYY-MM-DD') + INTERVAL '0' DAY + INTERVAL '5' YEAR,'YYYY-MM-DD') as fecha_fin_exigibilidad
    from dual
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $fecha_exigibilidad = $records[0]['fecha_exigibilidad'];
            $fecha_fin_exigibilidad = $records[0]['fecha_fin_exigibilidad'];


            $request['fecha_exigibilidad'] = $fecha_exigibilidad;
            $request['fecha_fin_exigibilidad'] = $fecha_fin_exigibilidad;


            //Toma los conceptos - 20170424
            $request['id_concepto_resol'] = str_replace(".", "", $request['id_concepto_resol']);
            $conceptos = $request['id_concepto_resol'];
            $conceptos = explode(',', $conceptos);

            $id = $conceptos[0];
            $request['id_conceptos'] = $request['id_concepto_resol'];
            $request['id_concepto_resol'] = $id;
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $cod_titulo = $request['cod_titulo'];
        $no_resolucion = '';
        if (isset($request['no_resolucion'])) {
            $no_resolucion = "and no_resolucion='" . $request['no_resolucion'] . "'";
        }


        //Toma los conceptos - 20170424
        $request['id_concepto_resol'] = str_replace(".", "", $request['id_concepto_resol']);
        $conceptos = $request['id_concepto_resol'];
        $conceptos = explode(',', $conceptos);

        /*
         *  Validar la operación, ya sea por SQL
         */
        for ($i = 0; $i < count($conceptos); $i++) {

            $id = $conceptos[$i];

            $sql = <<<EOD
SELECT * FROM cbr_resolucion_tit 
where 
cod_titulo = '$cod_titulo' 
and id_concepto_resol = $id 
$no_resolucion 
EOD;
            //insertar cada cdp
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {
                $errors['mensaje'] = "Ya se ingreso para el titulo una o varios registros de los mismos conceptos/no_resolucion, favor verificar.";
                $errors['servicio'] = "resolucion_titulo";
            }
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
